
<style scoped>
.user-panel {
  margin: 10px auto;
}
</style>
<template>
  <el-dialog
    :visible.sync="showDialog"
    :title="title"
    :modal-append-to-body="false"
    style="text-align:left;"
    @close="closeDialog"
    :close-on-click-modal="false"
  >
    <div class="user-panel" v-loading="loading">
      <el-form ref="form" :model="formModel" :rules="ruleValidate" :label-width="'100px'">
        <el-form-item label prop="id">
          <el-input v-model="formModel.id" placeholder="请输入" style="width:300px"></el-input>
        </el-form-item>
        <el-form-item label prop="createBy">
          <el-input v-model="formModel.createBy" placeholder="请输入" style="width:300px"></el-input>
        </el-form-item>
        <el-form-item label prop="createTime">
          <el-input v-model="formModel.createTime" placeholder="请输入" style="width:300px"></el-input>
        </el-form-item>
        <el-form-item label prop="updateBy">
          <el-input v-model="formModel.updateBy" placeholder="请输入" style="width:300px"></el-input>
        </el-form-item>
        <el-form-item label prop="updateTime">
          <el-input v-model="formModel.updateTime" placeholder="请输入" style="width:300px"></el-input>
        </el-form-item>
        <el-form-item label="是否删除" prop="delFlag">
          <el-input v-model="formModel.delFlag" placeholder="请输入是否删除" style="width:300px"></el-input>
        </el-form-item>
        <el-form-item label="流水号" prop="serialNumber">
          <el-input v-model="formModel.serialNumber" placeholder="请输入流水号" style="width:300px"></el-input>
        </el-form-item>
        <el-form-item label="充值金额" prop="buyAmount">
          <el-input v-model="formModel.buyAmount" placeholder="请输入充值金额" style="width:300px"></el-input>
        </el-form-item>
        <el-form-item label="充值度数" prop="buyElectricity">
          <el-input v-model="formModel.buyElectricity" placeholder="请输入充值度数" style="width:300px"></el-input>
        </el-form-item>
        <el-form-item label="支付类型:微信,支付宝,现金等" prop="buyType">
          <el-input
            v-model="formModel.buyType"
            placeholder="请输入支付类型:微信,支付宝,现金等"
            style="width:300px"
          ></el-input>
        </el-form-item>
      </el-form>
    </div>
    <span slot="footer" class="dialog-footer">
      <el-button @click="closeDialog">取 消</el-button>
      <el-button type="primary" @click="handleSubmit" :loading="submitting">确 定</el-button>
    </span>
  </el-dialog>
</template>
<script>
import Constant from "@/constant";
import rechargeRecordApi from "@/api/base/rechargeRecord";

export default {
  props: ["businessKey", "title"],
  data() {
    return {
      ruleValidate: {
        id: [{ required: true, message: "不能为空", trigger: "blur" }],
        createBy: [{ required: true, message: "不能为空", trigger: "blur" }],
        createTime: [{ required: true, message: "不能为空", trigger: "blur" }],
        updateBy: [{ required: true, message: "不能为空", trigger: "blur" }],
        updateTime: [{ required: true, message: "不能为空", trigger: "blur" }],
        delFlag: [
          { required: true, message: "是否删除不能为空", trigger: "blur" }
        ],
        serialNumber: [
          { required: true, message: "流水号不能为空", trigger: "blur" }
        ],
        buyAmount: [
          { required: true, message: "充值金额不能为空", trigger: "blur" }
        ],
        buyElectricity: [
          { required: true, message: "充值度数不能为空", trigger: "blur" }
        ],
        buyType: [
          {
            required: true,
            message: "支付类型:微信,支付宝,现金等不能为空",
            trigger: "blur"
          }
        ]
      },
      showDialog: true,
      loading: false,
      submitting: false,
      formModel: {}
    };
  },
  methods: {
    closeDialog() {
      this.$emit("close", false);
    },
    handleSubmit() {
      var self = this;

      this.$refs["form"].validate(valid => {
        if (valid) {
          (function() {
            var id = self.formModel.id;

            if (id == null || id.length == 0) {
              return rechargeRecordApi.add(self.formModel);
            } else {
              return rechargeRecordApi.update(self.formModel);
            }
          })().then(function(response) {
            var jsonData = response.data;

            if (jsonData.result) {
              self.$message({
                message: "保存成功!",
                type: "success"
              });

              self.$emit("close", true);
            } else {
              self.$message({
                message: jsonData.message + "",
                type: "warning"
              });

              self.$emit("close", false);
            }
          });
        }
      });
    }
  },
  mounted: function() {
    var self = this;

    (function() {
      if (self.businessKey.length == 0) {
        return rechargeRecordApi.create();
      } else {
        return rechargeRecordApi.edit(self.menuId);
      }
    })()
      .then(response => {
        var jsonData = response.data;
        self.loading = false;

        if (jsonData.result) {
          self.formModel = jsonData.data;
        } else {
          self.$message.error(jsonData.message + "");
        }
      })
      .catch(error => {
        self.$message.error(error + "");
      });
  }
};
</script>